import { SlashCommand, SlashCommandOption } from '../interfaces/SlashCommand';
import { ChannelType } from "discord-api-types/v10";
export declare class SlashCommandBuilder {
    private type;
    private application_id?;
    private guild_id?;
    name: string;
    name_localizations?: {
        [key in allowedLocales]: string;
    };
    description: string;
    description_localizations?: {
        [key in allowedLocales]: string;
    };
    options?: SlashCommandOptionBuilder[];
    default_member_permissions?: string;
    dm_permission?: boolean;
    constructor(data: SlashCommand);
}
export declare class SlashCommandOptionBuilder {
    type: OptionType;
    name: string;
    name_localizations?: {
        [key in allowedLocales]: string;
    };
    description: string;
    description_localizations?: {
        [key in allowedLocales]: string;
    };
    required?: boolean;
    choices?: {
        name: string;
        value: string | number;
    }[];
    options?: SlashCommandOptionBuilder[];
    channel_types?: (0 | 1 | 2 | 3 | 4 | 5 | 10 | 11 | 12 | 13 | 14 | 15)[];
    min_value?: number;
    max_value?: number;
    min_length?: number;
    max_length?: number;
    autocomplete?: boolean;
    constructor(data: SlashCommandOption);
}
export declare enum OptionType {
    Subcommand = 1,
    SubcommandGroup = 2,
    String = 3,
    Integer = 4,
    Boolean = 5,
    User = 6,
    Channel = 7,
    Role = 8,
    Mentionable = 9,
    Number = 10,
    Attachment = 11
}
export declare type allowedLocales = 'da' | 'de' | 'en-GB' | 'en-US' | 'es-ES' | 'fr' | 'hr' | 'it' | 'lt' | 'hu' | 'nl' | 'no' | 'pl' | 'pt-BR' | 'ro' | 'fi' | 'sv-SE' | 'vi' | 'tr' | 'cs' | 'el' | 'bg' | 'ru' | 'uk' | 'hi' | 'th' | 'zh-CN' | 'ja' | 'zh-TW' | 'ko';
export { ChannelType };
