"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EmbedBuilder = void 0;
const discord_js_1 = require("discord.js");
class EmbedBuilder extends discord_js_1.EmbedBuilder {
    title;
    description;
    url;
    color;
    timestamp;
    footer;
    image;
    thumbnail;
    author;
    fields;
    constructor(data) {
        super();
        if (data) {
            if (data.title) {
                this.title = data.title;
            }
            if (data.description) {
                this.description = data.description;
            }
            if (data.url) {
                this.url = data.url;
            }
            if (data.timestamp) {
                this.timestamp = data.timestamp;
            }
            if (data.footer) {
                this.footer = {
                    text: data.footer.text,
                    icon_url: data.footer.icon_url
                };
            }
            if (data.thumbnail) {
                this.thumbnail = {
                    url: data.thumbnail.url
                };
            }
            if (data.author) {
                this.author = {
                    name: data.author.name,
                    url: data.author.url,
                    icon_url: data.author.icon_url,
                    proxy_icon_url: data.author.proxy_icon_url
                };
            }
            if (data.fields) {
                this.fields = data.fields;
            }
            if (typeof data?.color === 'string') {
                this.color = parseInt(data.color.replace('#', ''), 16);
            }
            if (typeof data?.image === "string") {
                this.setImage(data.image);
            }
        }
    }
}
exports.EmbedBuilder = EmbedBuilder;
