"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEmojis = void 0;
class Emoji {
    name;
    id;
    animated;
    image;
    url;
    constructor(name, id, animated, image) {
        this.name = name;
        this.id = id;
        this.animated = animated;
        this.image = image;
        this.url = this.image;
    }
    toString() {
        return `<${this.animated ? 'a' : ''}:${this.name}:${this.id}>`;
    }
}
function getEmojis(content) {
    let args = content.replace(/></g, '> <').split(/ +/g);
    args = args.filter((arg) => arg.match(/<?(a)?:?(\w{2,32}):(\d{14,20})>?/));
    const emojis = [];
    for (const arg of args) {
        const matchedEmoji = arg.match(/<?(a)?:?(\w{2,32}):(\d{14,20})>?/);
        const [, isAnimated, name, id] = matchedEmoji;
        const animated = isAnimated === 'a' ? true : false;
        if (!emojis.some((e) => e.id === id)) {
            const emoji = new Emoji(name, id, animated, `${animated ?
                `https://cdn.discordapp.com/emojis/${id}.gif?v=1`
                :
                    `https://cdn.discordapp.com/emojis/${id}.png?v=1`}`);
            emojis.push(emoji);
        }
    }
    return emojis;
}
exports.getEmojis = getEmojis;
